//---------------------------------------------------------------------------
#include "Populations.h"

//HEADER FILES FOR REGISTERED POPULATION OBJECTS
#include "TreePopulation.h"

/*///////////////////////////////////////////////////////////////////////////
CreateObjects
// Edit history:
// -------------
// April 28, 2004 - Submitted in beta version (LEM)

///////////////////////////////////////////////////////////////////////////*/
void clPopulationManager::CreateObjects(xercesc::DOMDocument *p_oDoc){
  try {
    //If keep current is false - free memory
    if (m_iNumObjects > 0) FreeMemory();

    //Right now the only population we know how to create is the tree pop -
    //so do that if it's not already created
    if (0 == m_iNumObjects) {
      m_iNumObjects = 1;
      clTreePopulation *p_oTreePop;
      mp_oObjectArray = new clWorkerBase*[m_iNumObjects];
      p_oTreePop = new clTreePopulation(mp_oSimManager);
      mp_oObjectArray[0] = p_oTreePop;
      p_oTreePop->BarebonesDataSetup(p_oDoc);
    } //end of if (0 == m_iNumObjects)
  }
  catch(modelErr &err) {throw(err);}
  catch (modelMsg &msg) {throw(msg);} //non-fatal error
  catch(...) {
    modelErr stcErr;
    stcErr.iErrorCode = UNKNOWN;
    strcpy(stcErr.cFunction, "clPopulationManager::CreateObjects");
    throw(stcErr);
  }
}
//---------------------------------------------------------------------------
